/* Sistemas Integrados Teknisa
   Descrio: Gera previso de saida e retorno
              de produtos (Cadeiras, mesas, Talheres)
              no estoque.
   Data: 05/11/2007
   Criao: Welbert G. Moitinha
*/


CREATE OR REPLACE PROCEDURE PREVISAO_LOCACAO
   (P_CDFILIAL   IN  VARCHAR2,
    P_CDPRODINI  IN  VARCHAR2,
    P_CDPRODFIN  IN  VARCHAR2,
    P_DTINICIAL  IN  DATE,
    P_DTFINAL    IN  DATE,
    P_NROREPREVLOC IN VARCHAR2,
    P_IDCONSORCPE  IN VARCHAR2)
AS
   V_QTSALDDIA    FLOAT;
BEGIN

   DELETE FROM TRAB_OREPREVLOC
   WHERE CDFILPREVLOC = P_CDFILIAL
     AND NROREPREVLOC = P_NROREPREVLOC;

   DELETE FROM TRAB_ORESALDLOC
   WHERE CDFILSALDLOC = P_CDFILIAL
     AND NRORESALDLOC = P_NROREPREVLOC;


   FOR C_POSESTCONS IN( SELECT PC.CDPRODUTO, QTESTDIACON
                        FROM POSESTCONS PC, PRODUTO PR
                        WHERE PC.CDFILIAL = P_CDFILIAL
                          AND PC.CDPRODUTO = PR.CDPRODUTO
                          AND PR.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                          AND PC.DTPOSESTCON = (SELECT MAX(P.DTPOSESTCON)
                                                FROM POSESTCONS P
                                                WHERE P.CDFILIAL = P_CDFILIAL
                                                  AND P.CDPRODUTO = PR.CDPRODUTO
                                                  AND DTPOSESTCON <= P_DTINICIAL))LOOP
      INSERT INTO TRAB_OREPREVLOC
      (CDFILPREVLOC, NROREPREVLOC, DTOREPREVLOC, CDPRODPREVLOC, QTOREPREVLOC, IDOREPREVLOC)
      VALUES
      (P_CDFILIAL, P_NROREPREVLOC, P_DTINICIAL, C_POSESTCONS.CDPRODUTO,  C_POSESTCONS.QTESTDIACON, 'PI');

   END LOOP;

   FOR C_ORCAEVENTO IN(SELECT I.CDPRODUTO,
                             TO_DATE(TO_CHAR(I.DTENTITPED, 'DD/MM/YYYY' )) - NVL(NRDIASRESEST,0)  AS DTEVENTO,
                              SUM(QTITEMPED - NVL(QTEXPITEMPED,0)) AS QTITEMORCEVE,
                              NVL(NRTEMPREPEST,1) AS NRTEMPREPEST, 'SE' AS IDSITMOVI
                       FROM ITEMPEDIDO I, PRODUTO P, PRODFILI PF
                       WHERE I.CDFILIAL = P_CDFILIAL
                         AND I.IDSITITEMPED IN ('1', '2', '3')
                         AND I.CDPRODUTO = P.CDPRODUTO
                         AND P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                         AND TO_DATE( TO_CHAR( I.DTENTITPED, 'DD/MM/YYYY')) BETWEEN P_DTINICIAL AND P_DTFINAL
                         AND PF.CDFILIAL = P_CDFILIAL
                         AND PF.CDPRODUTO = I.CDPRODUTO
                       GROUP BY I.CDPRODUTO, TO_DATE(TO_CHAR(I.DTENTITPED, 'DD/MM/YYYY' )) - NVL(NRDIASRESEST,0), NRTEMPREPEST, NRDIASRESEST
                       UNION ALL
                       SELECT I.CDPRODUTO,
                              TO_DATE(TO_CHAR(I.DTENTITPED, 'DD/MM/YYYY' ))+ NVL(NRTEMPREPEST,1) AS DTEVENTO,
                              SUM(QTITEMPED - NVL(QTEXPITEMPED,0)) AS QTITEMORCEVE,
                              NVL(NRTEMPREPEST,1) AS NRTEMPREPEST, 'RE' AS IDSITMOVI
                       FROM ITEMPEDIDO I, PRODUTO P, PRODFILI PF
                       WHERE I.CDFILIAL = P_CDFILIAL
                         AND I.IDSITITEMPED IN ('1', '2', '3')
                         AND I.CDPRODUTO = P.CDPRODUTO
                         AND P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                         AND TO_DATE( TO_CHAR( I.DTENTITPED, 'DD/MM/YYYY')) BETWEEN P_DTINICIAL AND P_DTFINAL
                         AND PF.CDFILIAL = P_CDFILIAL
                         AND PF.CDPRODUTO = I.CDPRODUTO
                       GROUP BY I.CDPRODUTO, TO_DATE(TO_CHAR(I.DTENTITPED, 'DD/MM/YYYY' ))+ NVL(NRTEMPREPEST,1), NRTEMPREPEST, NRDIASRESEST
                       UNION ALL
                       SELECT I.CDPRODUTO,
                              TO_DATE(TO_CHAR(O.DTEVENTO, 'DD/MM/YYYY'))- NVL(NRDIASRESEST,0) AS DTEVENTO,
                              SUM(QTITEMORCEVE) AS QTITEMORCEVE,
                              NVL(NRTEMPREPEST,1) AS NRTEMPREPEST, 'SE' AS IDSITMOVI
                       FROM ORCAEVENTO O, ITEMORCAEVEN I, PRODUTO P, PRODFILI PF
                       WHERE O.CDFILIAL = I.CDFILIAL
                         AND O.NRORCAEVENTO = I.NRORCAEVENTO
                         AND O.NRSEQORCAEVE = I.NRSEQORCAEVE
                         AND O.IDSITUORCEVE = '1'
                         AND P_IDCONSORCPE = 'S'
                         AND I.CDPRODUTO = P.CDPRODUTO
                         AND P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                         AND TO_DATE( TO_CHAR( O.DTEVENTO, 'DD/MM/YYYY'))BETWEEN P_DTINICIAL AND P_DTFINAL
                         AND PF.CDFILIAL = O.CDFILIAL
                         AND PF.CDPRODUTO = I.CDPRODUTO
                         AND O.CDFILIAL = P_CDFILIAL
                       GROUP BY I.CDPRODUTO, TO_DATE(TO_CHAR(O.DTEVENTO, 'DD/MM/YYYY'))- NVL(NRDIASRESEST,0), NRTEMPREPEST, NRDIASRESEST
                       UNION ALL
                       SELECT I.CDPRODUTO,
                              TO_DATE( TO_CHAR(O.DTEVENTO, 'DD/MM/YYYY')) + NVL(NRTEMPREPEST,1) AS DTEVENTO,
                              SUM(QTITEMORCEVE) AS QTITEMORCEVE,
                              NVL(NRTEMPREPEST,1) AS NRTEMPREPEST, 'RE' AS IDSITMOVI
                       FROM ORCAEVENTO O, ITEMORCAEVEN I, PRODUTO P, PRODFILI PF
                       WHERE O.CDFILIAL = I.CDFILIAL
                         AND O.NRORCAEVENTO = I.NRORCAEVENTO
                         AND O.NRSEQORCAEVE = I.NRSEQORCAEVE
                         AND O.IDSITUORCEVE = '1'
                         AND P_IDCONSORCPE = 'S'
                         AND I.CDPRODUTO = P.CDPRODUTO
                         AND P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                         AND TO_DATE( TO_CHAR( O.DTEVENTO, 'DD/MM/YYYY'))BETWEEN P_DTINICIAL AND P_DTFINAL
                         AND PF.CDFILIAL = O.CDFILIAL
                         AND PF.CDPRODUTO = I.CDPRODUTO
                         AND O.CDFILIAL = P_CDFILIAL
                       GROUP BY I.CDPRODUTO, TO_DATE( TO_CHAR(O.DTEVENTO, 'DD/MM/YYYY')) + NVL(NRTEMPREPEST,1), NRTEMPREPEST, NRDIASRESEST )LOOP

      INSERT INTO TRAB_OREPREVLOC
       (CDFILPREVLOC, NROREPREVLOC, DTOREPREVLOC, CDPRODPREVLOC, QTOREPREVLOC, IDOREPREVLOC)
       VALUES
       (P_CDFILIAL, P_NROREPREVLOC,  C_ORCAEVENTO.DTEVENTO, C_ORCAEVENTO.CDPRODUTO, C_ORCAEVENTO.QTITEMORCEVE, C_ORCAEVENTO.IDSITMOVI);
   END LOOP;


   FOR C_ITEMSOLI IN(
                     SELECT P.CDPRODESTO, IT.DTPROGENTR, NVL(SUM(IT.QTSOLIPROD * P.VRFATOCONV),0) AS QTSOLIPROD
                     FROM PRODUTO P, ITEMSOLI IT
                     WHERE IT.CDFILSOLI = P_CDFILIAL
                       AND P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                       AND IT.CDPRODUTO = P.CDPRODUTO
                       AND IT.DTPROGENTR BETWEEN P_DTINICIAL AND P_DTFINAL
                     GROUP BY P.CDPRODESTO, IT.DTPROGENTR
                     )LOOP

      INSERT INTO TRAB_OREPREVLOC
      (CDFILPREVLOC, NROREPREVLOC, DTOREPREVLOC, CDPRODPREVLOC, QTOREPREVLOC, IDOREPREVLOC)
      VALUES
      (P_CDFILIAL, P_NROREPREVLOC, C_ITEMSOLI.DTPROGENTR, C_ITEMSOLI.CDPRODESTO, C_ITEMSOLI.QTSOLIPROD, 'SC');
   END LOOP;

   FOR C_ITEMAUTF IN (
                      SELECT P.CDPRODESTO, IT.DTPROGENTAF, NVL(SUM(IT.QTPROGENTAF * P.VRFATOCONV),0) AS QTPROGENTAF
                      FROM PRODUTO P, ITEMAUTF IT
                      WHERE IT.CDFILDEST   = P_CDFILIAL
                        AND IT.DTPROGENTAF BETWEEN P_DTINICIAL AND P_DTFINAL
                        AND P.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
                        AND IT.CDPRODUTO = P.CDPRODUTO
                        AND NOT EXISTS(SELECT A.CDFILLANC
                                       FROM AUTOFORNE A
                                       WHERE A.CDFILLANC  = IT.CDFILLANC
                                         AND A.CDFILDEST  = IT.CDFILDEST
                                         AND A.NRAUTOFORN = IT.NRAUTOFORN
                                         AND A.IDBAIXAAF  IN ('4','5','6'))
                      GROUP BY P.CDPRODESTO, IT.DTPROGENTAF) LOOP


      INSERT INTO TRAB_OREPREVLOC
      (CDFILPREVLOC, NROREPREVLOC, DTOREPREVLOC, CDPRODPREVLOC, QTOREPREVLOC, IDOREPREVLOC)
      VALUES
      (P_CDFILIAL, P_NROREPREVLOC, C_ITEMAUTF.DTPROGENTAF,  C_ITEMAUTF.CDPRODESTO , C_ITEMAUTF.QTPROGENTAF, 'AF');
   END LOOP;


   FOR C_PRODUTO IN(
                    SELECT DISTINCT CDPRODPREVLOC
                    FROM TRAB_OREPREVLOC
                    WHERE CDFILPREVLOC = P_CDFILIAL
                      AND NROREPREVLOC = P_NROREPREVLOC )LOOP

      V_QTSALDDIA := 0;
      FOR C IN(SELECT D.DTDATA AS DTOREPREVLOC, NVL(T.QTOREPREVLOC,0) AS QTOREPREVLOC
               FROM
                  DATA D, (SELECT DTOREPREVLOC,
                                  SUM(QTOREPREVLOC * DECODE(IDOREPREVLOC, 'SE',-1, 1)) AS QTOREPREVLOC
                           FROM TRAB_OREPREVLOC
                           WHERE CDFILPREVLOC = P_CDFILIAL
                           AND NROREPREVLOC = P_NROREPREVLOC
                           AND CDPRODPREVLOC = C_PRODUTO.CDPRODPREVLOC
                           GROUP BY DTOREPREVLOC) T
                  WHERE
                     D.DTDATA = T.DTOREPREVLOC(+)
                     AND D.DTDATA BETWEEN P_DTINICIAL AND P_DTFINAL
                  ORDER BY D.DTDATA
               ) LOOP

         V_QTSALDDIA := V_QTSALDDIA + C.QTOREPREVLOC;

         INSERT INTO TRAB_ORESALDLOC
            (CDFILSALDLOC, NRORESALDLOC, DTORESALDLOC, CDPRODSALDLOC, QTORESALDLOC)
         VALUES
            (P_CDFILIAL, P_NROREPREVLOC,  C.DTOREPREVLOC, C_PRODUTO.CDPRODPREVLOC, V_QTSALDDIA);
      END LOOP;
   END LOOP;
END;
/

BEGIN ATUVEROBJ('PREVISAO_LOCACAO','0.00.000'); END;
/



-- VERSAO --
BEGIN ATUVEROBJ('PREVISAO_LOCACAO','5.07.004'); END;
/


